﻿using Models;
using System;
using System.Collections.Generic;
using System.Collections.Immutable;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Endpoint
{
    public interface IAccountRecipesPreferences
    {
        public Account Account { get; }


        public void AddToFavorites(RecipeInfo info);
        public void RemoveFromFavorites(RecipeInfo info);
        public void SetReviewScore(RecipeInfo info, uint score);

        public AccountRecipeRate GetRate(RecipeInfo info);

        public ImmutableList<RecipeInfo> GetFavorites();

        public ImmutableList<RecipeInfo> GetRecommendedRecipes();

        public ImmutableList<(RecipeInfo, uint)> GetWeeklyList();

    }
}
