using Endpoint;
using LocalEndpoint;
using Models;
using ShoopNCook.Views;

namespace ShoopNCook.Pages;

public partial class MyListPage : ContentPage
{
	public MyListPage(Account account, IUserNotifier notifier, IRecipesService service)
    {
		InitializeComponent();

        IAccountRecipesPreferences preferences = service.GetPreferencesOf(account);
        preferences.GetWeeklyList().ForEach(tuple =>
        {
            RecipeInfo info = tuple.Item1;
            RecipesLayout.Children.Add(new StoredRecipeView(info, tuple.Item2, amount =>
            {
                Recipe recipe = service.GetRecipe(info);
                Shell.Current.Navigation.PushAsync(new RecipePage(recipe, notifier, preferences, amount));
            }));
        });

    }
}